(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../AnimationOptions.js"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.SizeAnimation = void 0;
    const AnimationOptions_js_1 = require("../../AnimationOptions.js");
    class SizeAnimation extends AnimationOptions_js_1.RangedAnimationOptions {
        constructor() {
            super();
            this.destroy = "none";
            this.speed = 5;
        }
        load(data) {
            super.load(data);
            if (!data) {
                return;
            }
            if (data.destroy !== undefined) {
                this.destroy = data.destroy;
            }
        }
    }
    exports.SizeAnimation = SizeAnimation;
});
